#ifndef MAIN_H
#define MAIN_H

#include <avr/io.h>
#include <avr/pgmspace.h>

#define F_CPU 18432000UL
#define STACKSIZE 7
#define RAMTOP 6144		// for max possible 4K Ram
#define XOFF 19
#define XON	 17
#define RESET 20		// printer reset

// type defs
typedef void (*pt2func)();

// function headers
void SpecialKey(void);
void InitProcessor(void);
void LoadROMs(void);
void AssignInstructionSet(void);
uint8_t memory(uint16_t PC);	// read a byte from memory

extern volatile uint8_t Areg,Breg,Creg,Dreg,Ereg,Hreg,Lreg,Mem;
extern volatile uint8_t Sflag,Zflag,Pflag,Cflag;
extern volatile uint16_t PC;
extern volatile int8_t SPtr;
extern volatile uint8_t scanKeyb;
extern volatile uint16_t ColRow;
extern volatile uint16_t Stack[STACKSIZE];
// extern volatile uint8_t memory[10240];
extern const uint8_t KRom[16384] PROGMEM;	// ROM image
extern const uint8_t K1000ZS[120] PROGMEM;	// char set translation to ASCII
extern volatile uint8_t KRam[6144];		// 2K Buffer + 4K genuine K1000 RAM
extern const uint8_t parity[256] PROGMEM;
extern volatile uint8_t dispBuffer[16];
extern volatile uint8_t sp_key;
extern volatile uint8_t keydown;
extern volatile uint8_t dispDelay;	// keep Display Status for some time
extern volatile uint8_t ix;			// pointer for RS232 incoming
extern volatile uint8_t ox;			// pointer for RS232 reading
extern volatile uint8_t buf[256];	// RS232 receive buffer
extern volatile uint8_t StopTransmission;	// flag for XOFF/XON protocol


#endif
