#ifndef MONITOR_H_
#define MONITOR_H_

// Definitions for Atmega 1284P
#define UART0_RECEIVE_INTERRUPT   USART0_RX_vect
#define UART0_TRANSMIT_INTERRUPT  USART0_UDRE_vect
#define UART0_STATUS   UCSR0A
#define UART0_CONTROL  UCSR0B
#define UART0_DATA     UDR0
#define UART0_UDRIE    UDRIE0

#ifndef USART_BAUDRATE
#define USART_BAUDRATE 9600
#endif

#define BAUD_PRESCALE (((F_CPU / (USART_BAUDRATE * 16UL))) - 1)

void monitor(void);
void uart_init(void);
void PrintLine(void);

#endif /* MONITOR_H_ */